# -*- coding:Utf8 -*-

###########################################
# MakeNavData : programme en Python 3.3.0 #
#           Jean-Olivier Loize            #
###########################################

# Importation de modules
from tkinter import *
from tkinter import filedialog
from tkinter import ttk
import sys
import os
import zipfile

#####################
# Fonctions locales #
#####################
def ValidFen(*args):
    bfen.set("OK")
    root.quit()

def QuitFen(*args):
    bfen.set("Quit")
    root.quit()

def AuRevoir(*args):# on quitte le logiciel proprement...
    root.destroy()
    sys.exit()

def ConvertCoord(chaine, choix, genre):    # choix est False pour une latitude, True pour une longitude
    # cas du "0"
    if genre == 0:
        esp = " "   # on complète avec des espaces
    if genre == 1:
        esp = "0"   # on complète avec des zéros et le signe "+" si nécessaire
    if genre == 2:
        esp = ""    # pas besoin de compléter
    if genre == 3:
        esp = "0"   # on complète avec des zéros sans indiquer le signe "+"
    # on traite le cas particulier d'une coordonnée 0
    if chaine == "0":
        coord = esp + "0.000000"
        if choix == True:
            coord = esp + coord
        if genre == 1:
            coord = "+" + coord     # le genre 1 prend un signe "+"
        else:
            coord = " " + coord     # on laisse un espace au lieu du signe
        return coord
    else:
        coord = ""
        signe = ""
        # le premier caractère est un signe moins ?
        if chaine[0] == "-":
            signe = "-"
            chaine = chaine[1:]     # on supprime le signe (on ne garde que la partie entière)
        else:
            if genre == 1:          # un genre 1 positif prend le signe positif
                signe = "+"
            else:
                signe = " "
        # on manque de chiffres ?
        while len(chaine) < 6:
            chaine = "0" + chaine
        # on isole les 6 derniers chiffres (décimales)
        tempo = chaine[-6:]         # ... que l'on mémorise
        chaine = chaine[:-6]        # avant de les supprimer
        # on s'occupe de la partie entière
        # cas d'une partie entière vide : on met au moins un zéro
        if chaine == "":
            chaine = "0"
            coord = "0"
        else:
            # si la chaine a des zéros en trop, on les supprime sauf le dernier !
            while (chaine[0] == "0" and len(chaine) > 1):
                chaine = chaine[1:]
            # on installe la partie entière
            coord = chaine
        # le signe est accolé au premier chiffre significatif (sauf genre 1 et 3)
        if (genre == 0 or genre == 2):
            coord = signe + coord
            signe = ""
        # on normalise le reste de la partie entière
        if len(chaine) == 1:                    # un seul chiffre significatif ?
            coord = esp + coord                 # ... on ajoute un caractère
            if choix == True:
                coord = esp + coord             # et encore un pour la longitude
        # on traite le cas d'une longitude sur 2 chiffres
        if len(chaine) == 2 and choix == True:
            coord = esp + coord                 # en ajoutant un caractère au besoin
        # on inclue les décimales
        coord = coord + "." + tempo
        # on inclue le signe (cas du genre 1)
        coord = signe + coord
        return coord

def ExtrairePDV(chaine, racImp, racExp):    # Extraire SID et STAR pour le FMS
    if chaine[0] == "*":                    # Tout extraire ? Il est fou le gars !
        indexCar = 4
        quelAirport = "AAAA.txt"            # nom du premier fichier à examiner
    else:
        if len(chaine) < 4:
            indexCar = 4 - len(chaine)
            quelAirport = chaine + ("A" * indexCar) + ".txt"
        else:
            indexCar = 0
            quelAirport = chaine + ".txt"
    # Préparation du dossier de destination
    racExp = racExp + "PourFMS"
    if os.path.isdir(racExp) == False:      # Le dossier "PourFMS" n'existe pas ?
        flagWork = os.mkdir(racExp)         # Création de ce dossier
    racExp = racExp + os.sep                # mémoriser le chemin de destination des fichiers à créer
    # Routine d'extraction des SID
    flagSID = True
    dossierEcr = racExp + "SID"
    if os.path.isdir(dossierEcr) == False:  # Le dossier "SID" n'existe pas ?
        flagWork = os.mkdir(dossierEcr)     # Création de ce dossier
    dossierEcr = dossierEcr + os.sep        # mémoriser le chemin de destination des fichiers à créer
    dossierLu = racImp + "SID" + os.sep     # mémoriser le chemin d'origine des fichiers Navigraph
    flagEnd = False
    while flagEnd == False:
        ficLu = dossierLu + quelAirport
        if os.path.isfile(ficLu) == True:
            # Le fichier Navigraph existe, on le traite
            ficEcr = dossierEcr + quelAirport[:-4]  # la destination est un dossier au nom de l'aéroport
            FairePDV(ficLu, ficEcr, flagSID)
        # On traite le nom du fichier suivant possible
        # Note perso : il serait plus simple de naviguer dans une liste de fichiers pré-sélectionnés
        # ... mais je n'ai pas trouvé une fonction permettant de le faire avec un caractère "*"
        # ... et même si c'est faisable, on risque de saturer la RAM (plusieurs milliers de fichiers)
        if indexCar == 0:   # cas où 4 caractères sont renseignés (1 seul aéroport)
            flagEnd = True
        else:
            if quelAirport[3] == "Z":   # si le dernier caractère est un Z
                if indexCar == 1:       # si 3 caractères ont été tapé, on sort de la boucle
                    flagEnd = True
                else:
                    if quelAirport[2] == "Z":   # si l'avant-dernier caractère est un Z
                        if indexCar == 2:       # si 2 caractères ont été tapé, on sort de la boucle
                            flagEnd = True
                        else:
                            if quelAirport[1] == "Z":   # etc.
                                if indexCar == 3:       # etc.
                                    flagEnd = True
                                else:
                                    if quelAirport[0] == "Z":   # cas du fou qui veut tout...
                                        if indexCar == 4:
                                            flagEnd = True
                                        else:
                                            pass    # normalement, c'est impossible d'arriver ici...
                                    else:
                                        # on passe à la lettre suivante en 1ère pos.
                                        quelAirport = chr(ord(quelAirport[0])+1) + "AAA.txt"
                                        print("SID de la région " + quelAirport[0])
                            else:
                                # lettre suivante en 2ème pos.
                                quelAirport = quelAirport[0:1] + chr(ord(quelAirport[1])+1)+ "AA.txt"
                                print("SID du pays " + quelAirport[0:2])
                    else:
                        # lettre suivante en 3ème pos.
                        quelAirport = quelAirport[0:2] + chr(ord(quelAirport[2])+1) + "A.txt"
                        print("SID de la zone " + quelAirport[0:3])
            else:
                # lettre suivante en 4ème pos.
                quelAirport = quelAirport[0:3] + chr(ord(quelAirport[3])+1)+ ".txt"
    # Routine d'extraction des STAR
    flagSID = False
    print("Création des STAR")
    dossierEcr = racExp + "STAR"
    if os.path.isdir(dossierEcr) == False:      # Le dossier "STAR" n'existe pas ?
        flagWork = os.mkdir(dossierEcr)         # Création de ce dossier
    dossierEcr = dossierEcr + os.sep            # mémoriser le chemin de destination des fichiers à créer
    dossierLu = racImp + "STAR" + os.sep        # mémoriser le chemin d'origine des fichiers Navigraph
    flagEnd = False
    while flagEnd == False:
        ficLu = dossierLu + quelAirport
        if os.path.isfile(ficLu) == True:
            # Le fichier Navigraph existe, on le traite
            ficEcr = dossierEcr + quelAirport[:-4]  # la destination est un dossier au nom de l'aéroport
            FairePDV(ficLu, ficEcr, flagSID)
        # On traite le nom du fichier suivant possible
        # Note perso : il serait plus simple de naviguer dans une liste de fichiers pré-sélectionnés
        # ... mais je n'ai pas trouvé une fonction permettant de le faire avec un caractère "*"
        # ... et même si c'est faisable, on risque de saturer la RAM (plusieurs milliers de fichiers)
        if indexCar == 0:   # cas où 4 caractères sont renseignés (1 seul aéroport)
            flagEnd = True
        else:
            if quelAirport[3] == "Z":   # si le dernier caractère est un Z
                if indexCar == 1:       # si 3 caractères ont été tapé, on sort de la boucle
                    flagEnd = True
                else:
                    if quelAirport[2] == "Z":   # si l'avant-dernier caractère est un Z
                        if indexCar == 2:       # si 2 caractères ont été tapé, on sort de la boucle
                            flagEnd = True
                        else:
                            if quelAirport[1] == "Z":   # etc.
                                if indexCar == 3:       # etc.
                                    flagEnd = True
                                else:
                                    if quelAirport[0] == "Z":   # cas du fou qui veut tout...
                                        if indexCar == 4:
                                            flagEnd = True
                                        else:
                                            pass    # normalement, c'est impossible d'arriver ici...
                                    else:
                                        # on passe à la lettre suivante en 1ère pos.
                                        quelAirport = chr(ord(quelAirport[0])+1) + "AAA.txt"
                                        print("STAR de la région " + quelAirport[0])
                            else:
                                # lettre suivante en 2ème pos.
                                quelAirport = quelAirport[0:1] + chr(ord(quelAirport[1])+1)+ "AA.txt"
                                print("STAR du pays " + quelAirport[0:2])
                    else:
                        # lettre suivante en 3ème pos.
                        quelAirport = quelAirport[0:2] + chr(ord(quelAirport[2])+1) + "A.txt"
                        print("STAR de la zone " + quelAirport[0:3])
            else:
                # lettre suivante en 4ème pos.
                quelAirport = quelAirport[0:3] + chr(ord(quelAirport[3])+1)+ ".txt"

def FairePDV(ficLu, dossierEcr, flagSID):    # Fabrique de SID ou STAR au format FMS
    # Ouvrir le fichier Navigraph
    objLu = open(ficLu, mode="r", buffering=1)
    # Créer le dossier de destination si nécessaire
    if os.path.isdir(dossierEcr) == False:
        flagWork = os.mkdir(dossierEcr)
    # Lecture du fichier jusqu'à la fin
    flagEnd = False
    flagClose = False   # fermeture d'un plan de vol à faire si True
    flagPrem = True     # première ligne du plan de vol en cours ?
    walt = "00000"          # on se prépare à mémoriser une altitude
    while flagEnd == False:
        # Lire une ligne de la SID/STAR
        ligneLu = objLu.readline()
        if ligneLu == "":
            # on a atteint la fin du fichier
            flagEnd = True
        else:
            # cas d'une ligne de séparation entre deux SID/STAR
            if len(ligneLu) < 3:
                flagClose = True        # il faut fermer le plan de vol en cours et lire la ligne suivante
            else:
                # première ligne d'une SID/STAR
                if ligneLu[0] == "P":
                    if flagClose == True:           # un précédent plan de vol était en cours ?
                        flagClose = False
                        flagPrem = True
                        walt = "00000"
                        # on cloture le précédent plan de vol
                        j = 1
                        while j < 10:   # ...en terminant le fichier FMS par quelques lignes vides
                            j = j + 1
                            ligneEcr = "0 ---- 0 0.000000 0.000000\n"
                            objEcr.write(ligneEcr)
                        objEcr.close()              # ... et on le ferme
                    ligneLu = ligneLu[2:]           # on passe les deux premiers caractères
                    i = ligneLu.index("|")          # on cherche le premier séparateur
                    nomSS = ligneLu[:i]             # on isole le nom de la SID/STAR
                    ligneLu = ligneLu[(i + 1):]     # on garde le reste de la ligne
                    i = ligneLu.index("|")          # on cherche le séparateur suivant
                    noPiste = ligneLu[:i]           # on isole le numéro de la piste
                    ligneLu = ligneLu[(i + 1):]     # on garde le reste de la ligne
                    i = ligneLu.index("|")          # on cherche le séparateur suivant
                    nomFin = ligneLu[:i]            # on isole le dernier pas
                    nbPas = ligneLu[(len(ligneLu) - 2)]   # on garde aussi le dernier caractère (nombre de pas)
                    if ligneLu[(len(ligneLu)-3)] != "|":            # l'avant-dernier n'est pas un séparateur ?
                        nbPas = ligneLu[(len(ligneLu)-3)] + nbPas   # il y a donc plus de 9 pas dans la SID/STAR
                    # Créer le fichier de destination
                    if flagSID == True:     # changement de la forme du nom entre une SID et une STAR
                        ficEcr = dossierEcr + os.sep + nomSS + "_Rwy" + noPiste + "_to_" + nomFin + ".fms"
                    else:
                        ficEcr = dossierEcr + os.sep + nomSS + "_" + nomFin + "_to_Rwy" + noPiste + ".fms"
                    objEcr = open(ficEcr, mode="w")
                    # Créer l'en-tête du fichier de destination
                    if os.sep == "/":
                        ligneEcr = "A\n"    # En-tête pour Mac ou Linux
                    else:
                        ligneEcr = "I\n"    # En-tête pour WC, PC et autres cochonneries
                    ligneEcr = ligneEcr + "3 version\n1\n" + nbPas +"\n"
                    objEcr.write(ligneEcr)
                else:
                    # traitement des pas de la SID/STAR
                    ligneLu = ligneLu[2:]       # on extrait les deux premiers caractères ("S|")
                    i = ligneLu.index("|")      # on cherche le premier séparateur
                    nomPas = ligneLu[:i]        # on récupère le nom du pas
                    ligneLu = ligneLu[(i + 1):] # on garde le reste de la ligne
                    i = ligneLu.index("|")      # on passe au séparateur suivant
                    wlat = ligneLu[:i]          # on isole la latitude
                    ligneLu = ligneLu[(i + 1):] # on garde le reste de la ligne
                    i = ligneLu.index("|")      # on cherche le séparateur suivant
                    wlon = ligneLu[:i]          # on isole la longitude
                    ligneLu = ligneLu[(i + 1):] # on garde le reste de la ligne
                    j=1
                    while j < 10:               # on saute les 10 données suivantes inexploitables par le FMS
                        j = j + 1
                        i = ligneLu.index("|")
                        ligneLu = ligneLu[(i + 1):]
                    i = ligneLu.index("|")      # on cherche le séparateur suivant
                    walti = ligneLu[:i]         # on garde l'altitude minimale imposée
                    while len(walti) < 5:       # que l'on normalise sur 5 caractères
                        walti = "0" + walti
                    # si l'altitude n'est pas nulle on l'affecte à l'altitude en cours
                    if walti != "00000":
                        walt = walti
                    ###############################
                    # Traitement des types de pas #
                    ###############################
                    # cas d'un espace (un arc-DME que le FMS ne sait pas traiter) ou d'un pas sans nom (au cas où...)
                    if (nomPas == "" or nomPas == " "):
                        pass    # on ne fait rien !
                    else:
                        # cas particulier d'un pas en bout de piste (traité sur le mode d'un point GPS)
                        wnom = nomPas[:2] + noPiste
                        if wnom == nomPas:
                            nomPas = ""                     # on efface le nom du pas qui ne sous sert pas ici...
                            # on normalise le nom d'un point GPS pour le FMS
                            wtxt = ConvertCoord(wlat, False, 1)
                            nomGPS = wtxt[0:7]
                            nomGPS = nomGPS + "_"           # un underscore en séparateur
                            wtxt = ConvertCoord(wlon, True, 1)
                            nomGPS = nomGPS + wtxt[0:8]
                            wlat = ConvertCoord(wlat, False, 2) # on normalise la latitude
                            wlon = ConvertCoord(wlon, True, 2)  # on normalise la longitude
                            ligneEcr = "28 " + nomGPS + " " + walt + " " + wlat + " " + wlon + "\n"
                        else:
                            # normalisation des latitudes et longitudes pour les autres pas
                            wlat = ConvertCoord(wlat, False, 2)
                            wlon = ConvertCoord(wlon, True, 2)
                        # cas d'un waypoint (4 ou 5 caractères)
                        if (len(nomPas) == 4 or len(nomPas) == 5):
                            ligneEcr = "11 " + nomPas + " " + walt + " " + wlat + " " + wlon + "\n"
                        # cas d'un VOR (3 caractères)
                        if len(nomPas) == 3:
                            ligneEcr = "3 " + nomPas + " " + walt + " " + wlat + " " + wlon + "\n"
                        # cas d'un NDB (1 ou 2 caractères)
                        if (len(nomPas) == 1 or len(nomPas) == 2):
                            ligneEcr = "2 " + nomPas + " " + walt + " " + wlat + " " + wlon + "\n"
                        # on écrit la ligne construite dans le fichier FMS
                        objEcr.write(ligneEcr)
                        if flagPrem == True:
                            flagPrem = False
                            objEcr.write(ligneEcr)  # on écrit la première ligne deux fois (bug FMS ?)
    # on cloture le dernier plan de vol construit
    j = 1
    while j < 10:   # en terminant le fichier FMS par quelques lignes vides
        j = j + 1
        ligneEcr = "0 ---- 0 0.000000 0.000000\n"
        objEcr.write(ligneEcr)
    # on ferme les fichiers
    objLu.close()
    objEcr.close()

######################
# Corps du programme #
######################
root = Tk()# Création de la fenêtre
root.title("MakeNavData")
cadre = ttk.Frame(root, padding="10 5 10 5")
cadre.grid(column=0, row=0, sticky=(N, W, E, S))
cadre.columnconfigure (0, weight=1)
cadre.rowconfigure(0, weight=1)

# Initialisation des éléments de la fenêtre
texte1 = ttk.Label(cadre,
                   text=u"Ce programme a pour objectif de rendre utilisable par X-Plane\n" +
                   "les données fournies par Navigraph (données payantes)\n" +
                   "à partir de leur fichier 'VASFMC_NATIVE_xxxx.zip'",
                   justify=CENTER, wraplength=400)
ligneSep = ttk.Separator(cadre, orient=HORIZONTAL)
texte2 = ttk.LabelFrame(cadre, text=u"Fichiers à créer :", padding="5 5 5 5")
bfix = IntVar()
bfix.set(1)
boiteFix = ttk.Checkbutton(cadre, text="Fichier 'earth.fix.dat'", variable=bfix)
bawy = IntVar()
bawy.set(0)
boiteAwy = ttk.Checkbutton(cadre, text="Fichier 'earth.awy.dat'", variable=bawy)
texte3 = ttk.LabelFrame(cadre, text=u"SID et STAR de ces aéroports :", padding="5 5 5 5")
texte4 = ttk.Label(cadre, text=u"ICAO n°1 :")
demand1 = ttk.Entry(cadre, exportselection=0, width=4)
texte5 = ttk.Label(cadre, text=u"ICAO n°2 :")
demand2 = ttk.Entry(cadre, exportselection=0, width=4)
texte6 = ttk.Label(cadre, text=u"ICAO n°3 :")
demand3 = ttk.Entry(cadre, exportselection=0, width=4)
texte7 = ttk.Label(cadre, text=u"ICAO n°4 :")
demand4 = ttk.Entry(cadre, exportselection=0, width=4)
texte8 = ttk.LabelFrame(cadre, text=u"Mettre à jour 'earth.nav.dat' et 'apt.dat' :", padding="5 5 5 5")
texte9 = ttk.Label(cadre, text=u"Les fichiers correspondant de votre dossier XPlane\n" +
                   "doivent se trouver dans le même dossier que les\n" +
                   "données issues de Navigraph...", justify=CENTER, wraplength=350)
bnav = IntVar()
bnav.set(0)
boiteNav = ttk.Checkbutton(cadre, text="Fichier 'earth_nav.dat'", variable=bnav)
bapt = IntVar()
bapt.set(0)
boiteApt = ttk.Checkbutton(cadre, text="Fichier 'apt.dat'", variable=bapt)
bfen = StringVar()  # Variable de type texte pour contrôler la suite du logiciel
bfen.set("Close")   # Indiquera que la fenêtre a été fermée par l'utilisateur, sans cliquer sur un bouton
boutonOK = ttk.Button(cadre, text="OK", command=ValidFen, width=8)
boutonQuit = ttk.Button(cadre, text="Quitter", command=QuitFen, width=8)

# Mise en place des éléments dans la fenêtre
texte1.grid(column=0, row=0, columnspan=4, sticky=(N), padx=5, pady=5)
ligneSep.grid(column=0, row=1, columnspan=4, sticky=(W, E), padx=5, pady=5)
texte2.grid(column=0, row=2, columnspan=4, sticky=(W, E), padx=5, pady=5)
boiteFix.grid(in_=texte2, column=0, row=3, sticky=(W), padx=5, pady=5)
boiteAwy.grid(in_=texte2, column=3, row=3, sticky=(E), padx=5, pady=5)
texte3.grid(column=0, row=4, columnspan=4, sticky=(W, E), padx=5, pady=5)
texte4.grid(in_=texte3, column=0, row=5, sticky=(W), padx=5, pady=5)
demand1.grid(in_=texte3, column=1, row=5, sticky=(W), padx=5, pady=5)
texte5.grid(in_=texte3, column=2, row=5, sticky=(W), padx=5, pady=5)
demand2.grid(in_=texte3, column=3, row=5, sticky=(W), padx=5, pady=5)
texte6.grid(in_=texte3, column=0, row=6, sticky=(W), padx=5, pady=5)
demand3.grid(in_=texte3, column=1, row=6, sticky=(W), padx=5, pady=5)
texte7.grid(in_=texte3, column=2, row=6, sticky=(W), padx=5, pady=5)
demand4.grid(in_=texte3, column=3, row=6, sticky=(W), padx=5, pady=5)
texte8.grid(column=0, row=7, columnspan=4, sticky=(W, E), padx=5, pady=5)
texte9.grid(in_=texte8, column=0, row=8, columnspan=4, sticky=(N), padx=5, pady=5)
boiteNav.grid(in_=texte8, column=0, row=9, sticky=(W), padx=5, pady=5)
boiteApt.grid(in_=texte8, column=3, row=9, sticky=(E), padx=5, pady=5)
boutonOK.grid(column=0, row=10, sticky=(W), padx=5, pady=5)
boutonQuit.grid(column=3, row=10, sticky=(E), padx=5, pady=5)

# Inactiver les options non encore disponibles
#demand1.state(["!disabled", "disabled"])
#demand2.state(["!disabled", "disabled"])
#demand3.state(["!disabled", "disabled"])
#demand4.state(["!disabled", "disabled"])
boiteNav.state(["!disabled", "disabled"])
boiteApt.state(["!disabled","disabled"])

# Comportement général de la fenêtre
root.resizable(False, False)

# Centrer la fenêtre au quart de la hauteur de l'écran (marche pas !)
#root.update_idletasks()
#fenW = root.winfo_height()
#fenH = root.winfo_width()
#ecrW = (root.winfo_screenwidth() - fenW)/2
#ecrH = (root.winfo_screenheight() - fenH)/4
#root.geometry("%dx%d+%d+%d" % (fenW, fenH, ecrW, ecrH))
root.update()
root.geometry(root.geometry())

# On affiche la fenêtre et on attend le choix de l'utilisateur
root.mainloop()

# L'utilisateur a validé ?
flagFen = bfen.get()
if flagFen != "OK":
    AuRevoir()

# On demande à l'utilisateur de sélectionner le fichier VASFMC_NATIVE
cheminRacine = filedialog.askopenfilename(defaultextension=".zip",
                                          title="Ouvrir le fichier 'VASFMC_NATIVE_xxxx.zip'")
if cheminRacine != "":                                      # L'utilisateur a sélectionné un fichier ?
    if "VASFMC_NATIVE" in cheminRacine:                     # Est-ce le bon ?
        sourceZip = zipfile.ZipFile(cheminRacine,"r")       # Mémoriser le fichier zip sélectionné
        cheminRacine = cheminRacine[:-4] + os.sep           # Mémoriser le chemin du dossier dézippé (en éliminant ".zip")
        print(cheminRacine)
        nomCycle = cheminRacine[-5:-1]                      # Mémoriser le cycle
        if os.path.isdir(cheminRacine) == False:            # Le dossier décompacté n'existe pas ?
            sourceZip.extractall(cheminRacine)              # Extraire l'archive si ce n'est déjà fait !
    else:
            AuRevoir()
else:
        AuRevoir()

# On récupère les options choisies par l'utilisateur
flagFix = bfix.get()
flagAwy = bawy.get()
icao1 = str.upper(demand1.get())
icao2 = str.upper(demand2.get())
icao3 = str.upper(demand3.get())
icao4 = str.upper(demand4.get())
flagNav = bnav.get()
flagApt = bapt.get()
root.destroy()          # À propos, on n'a plus besoin de la fenêtre !!!

# Préparer le dossier de réception
cheminExport = cheminRacine[:-19]           # on place la racine  de destination au niveau du dossier de données Navigraph
cheminExport = cheminExport + "PourXPlane"
if os.path.isdir(cheminExport) == False:    # Le dossier "PourXPlane" n'existe pas ?
    flagWork = os.mkdir(cheminExport)       # Création de ce dossier
cheminExport = cheminExport + os.sep        # mémoriser le chemin de destination des fichiers à créer

###########################################
# Option fichier "earth_fix.dat" demandée #
###########################################
if flagFix == 1:
    print("Création du fichier 'earth_fix.dat'")
    # Ouvrir le fichier "Waypoints.txt"
    fichierImport = cheminRacine + "Waypoints.txt"
    objetImport = open(fichierImport, mode="r", buffering=1)
    # Créer le fichier de destination
    fichierExport = cheminExport + "earth_fix.dat"
    objetExport = open(fichierExport, mode="w")
    # On créé l'en-tête
    if os.sep == "/":
        ligneExport = "A\n"     # En-tête pour Mac ou Linux
    else:
        ligneExport = "I\n"     # En-tête pour WC, PC et autres cochonneries
    # On construit la ligne avec la version et le cycle en cours de traitement
    ligneExport = ligneExport + "600 version - cycle : " + nomCycle
    ligneExport = ligneExport + " - construit par MakeNavData (joloize)\n\n"
    objetExport.write(ligneExport)
    # On construit le fichier des waypoints
    while True:
        ligneImport = objetImport.readline()
        if ligneImport == "":
            # fin du fichier
            break
        # traitement des waypoints
        i = ligneImport.index("|")          # on cherche le premier caractère "|"
        nomFix = ligneImport[:i]            # on isole le nom du waypoint
        ligneImport = ligneImport[(i+1):]   # on garde le reste de la ligne sans le séparateur
        i = ligneImport.index("|")          # oncherche le séparateur suivant
        wlat = ligneImport[:i]              # on isole la latitude
        ligneImport = ligneImport[(i+1):]   # on garde le reste de la ligne
        i = ligneImport.index("|")          # oncherche le séparateur suivant
        wlon = ligneImport[:i]              # on isole la latitude
        ligneImport = ligneImport[(i+1):]   # on garde le reste de la ligne
        wlat = ConvertCoord(wlat, False, 0) # conversion d'une latitude
        wlon = ConvertCoord(wlon, True, 0)  # conversion d'une longitude
        # on écrit la ligne et on poursuit la lecture du fichier
        ligneExport = wlat + " " + wlon + " " + nomFix + "\n"
        objetExport.write(ligneExport)
    # Écrire la dernière ligne du fichier "earth_fix"
    ligneExport = "99\n"
    objetExport.write(ligneExport)
    # Fermeture des fichiers
    objetImport.close()
    objetExport.close()

###########################################
# Option fichier "earth_awy.dat" demandée #
###########################################
if flagAwy == 1:
    print("Création du fichier 'earth_awy.dat'")
    # Ouvrir le fichier "ATS.txt"
    fichierImport = cheminRacine + "ATS.txt"
    objetImport = open(fichierImport, mode="r", buffering=1)
    # Créer le fichier de destination
    fichierExport = cheminExport + "earth_awy.dat"
    objetExport = open(fichierExport, mode="w")
    # On créé l'en-tête
    if os.sep == "/":
        ligneExport = "A\n"     # En-tête pour Mac ou Linux
    else:
        ligneExport = "I\n"     # En-tête pour WC, PC et autres cochonneries
    # On construit la ligne avec la version et le cycle en cours de traitement
    ligneExport = ligneExport + "640 version - cycle : " + nomCycle
    ligneExport = ligneExport + " - construit par MakeNavData (joloize)\n\n"
    objetExport.write(ligneExport)
    # On construit le fichier des airways
    while True:
        ligneImport = objetImport.readline()
        if ligneImport == "":
            # fin du fichier
            break
        # traitement des airways
        if len(ligneImport) < 3:        # une ligne de séparation ?
            pass                        # on laisse tomber cette ligne
        else:
            if ligneImport[0] == "A":               # une ligne contenant le nom de l'airway
                ligneImport = ligneImport[2:]       # on supprime les deux premiers caractères
                i = ligneImport.index("|")          # on cherche le premier caractère "|"
                nomAwy = ligneImport[:i]            # on mémorise le nom de l'airway pour les branches ci-après
                while len(nomAwy) <= 5:
                    nomAwy = nomAwy + " "           # on complète le nom avec des espaces si nécessaire
                ligneImport = ligneImport[(i+1):]   # on garde le reste de la ligne sans le séparateur
                # et on ne fait rien de plus !
            else:                                   # une ligne concernant une branche d'airway
                ligneImport = ligneImport[2:]       # on supprime les deux premiers caractères
                # on isole le nom du point de départ de la branche
                i = ligneImport.index("|")
                wnom = ligneImport[:i]
                while len(wnom) <= 5:
                    wnom = wnom + " "               # on complète le nom avec des espaces si nécessaire
                ligneImport = ligneImport[(i+1):]
                # ... sa latitude
                i = ligneImport.index("|")
                wlat = ligneImport[:i]
                ligneImport = ligneImport[(i+1):]
                wlat = ConvertCoord(wlat, False, 3)
                # ... sa longitude
                i = ligneImport.index("|")
                wlon = ligneImport[:i]
                ligneImport = ligneImport[(i+1):]
                wlon = ConvertCoord(wlon, True, 3)
                # on enregistre le point de départ
                ligneExport = wnom + " " + wlat + " " + wlon
                # on isole le nom du point d'arrivée de la branche
                i = ligneImport.index("|")
                wnom = ligneImport[:i]
                while len(wnom) <= 5:
                    wnom = wnom + " "               # on complète le nom avec des espaces si nécessaire
                ligneImport = ligneImport[(i+1):]
                # ... sa latitude
                i = ligneImport.index("|")
                wlat = ligneImport[:i]
                ligneImport = ligneImport[(i+1):]
                wlat = ConvertCoord(wlat, False, 3)
                # ... sa longitude
                i = ligneImport.index("|")
                wlon = ligneImport[:i]
                ligneImport = ligneImport[(i+1):]
                wlon = ConvertCoord(wlon, True, 3)
                # on enregistre le point d'arrivée
                ligneExport = ligneExport + " " + wnom + " " + wlat + " " + wlon
                # on complète avec des données bidon...
                ligneExport = ligneExport + " 1 050 600 " + nomAwy + "\n"
                objetExport.write(ligneExport)
    # Écrire la dernière ligne du fichier "earth_awy"
    ligneExport = "99\n"
    objetExport.write(ligneExport)
    # Fermeture des fichiers
    objetImport.close()
    objetExport.close()

#######################
# Choix des aéroports #
#######################

# premier aéroport demandé
if icao1 != "":
    print("Création des SID et STAR pour " + icao1)
    ExtrairePDV(icao1, cheminRacine, cheminExport)

# deuxième aéroport demandé
if icao2 != "":
    print("Création des SID et STAR pour " + icao2)
    ExtrairePDV(icao2, cheminRacine, cheminExport)

# troisième aéroport demandé
if icao3 !="":
    print("Création des SID et STAR pour " + icao3)
    ExtrairePDV(icao3, cheminRacine, cheminExport)

# quatrième aéroport demandé
if icao4 != "":
    print("Création des SID et STAR pour " + icao4)
    ExtrairePDV(icao4, cheminRacine, cheminExport)

########################################
# Mise à jour du fichier earth_nav.dat #
########################################
if flagNav == 1:
    print("Mise à jour du fichier 'earth_nav.dat'")
    pass    # À FAIRE ############

##################################
# Mise à jour du fichier apt.dat #
##################################
if flagApt == 1:
    print("Mise à jour du fichier 'apt.dat'")
    pass    # À FAIRE ############

print("Fin du programme...")
# Cloture du programme
sys.exit()
